Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2398 by niro, Tue Jan 7 13:06:55 2014 UTC revision 2415 by niro, Tue Jan 7 13:36:41 2014 UTC
# Line 22  die() Line 22  die()
22   exit 1   exit 1
23  }  }
24    
25  # configuration  # load common includes
26  if [ -e %SYSCONFDIR%/installer.conf ]  for inc in %SYSCONFDIR%/installer.conf \
27  then   ${INSTALLER_LIBDIR}/functions/common.sh \
28   source %SYSCONFDIR%/installer.conf   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29  else   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30   die "/etc/installer.conf not found"   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31  fi  do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41  # -> now in images.conf  # -> now in images.conf
# Line 45  else Line 52  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59    # some sane defaults
60  CDROOT="${DEFAULT_CDROOT}"  CDROOT="${DEFAULT_CDROOT}"
61  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
62    KERNELPKG="${DEFAULT_KERNELPKG}"
63  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75    trap_exit()
76    {
77     is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84     exit 1
85    }
86    
87  dialog_die()  dialog_die()
88  {  {
89   ERROR="$1"   ERROR="$1"
# Line 100  dialog_warning() Line 108  dialog_warning()
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(dialog \
131   --backtitle "${TITLE}" \   --backtitle "${TITLE}" \
132   --title "[ Festplatten Partitionierung ]" \   --title "[ Festplatten Partitionierung ]" \
133   --cancel-label "Abbrechen" \   --cancel-label "Abbrechen" \
# Line 157  dialog_setup_system_menu() Line 139  dialog_setup_system_menu()
139   "" "" \   "" "" \
140   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
141   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
142   "3" "Flash-Speicher (Manuell)")   retval=$?
143   RES=$?   [[ ${retval} -eq 1 ]] && return 1
144   [[ ${RES} -eq 1 ]] && return 1   if [[ ${retval} -eq 0 ]]
  if [[ ${RES} -eq 0 ]]  
145   then   then
146   case "${i}" in   case "${mode}" in
147   "1") run_install_auto ;;   "1") run_install_auto ;;
148   "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
149   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
150   esac   esac
151   fi   fi
# Line 235  dialog_hardware_detection() Line 215  dialog_hardware_detection()
215   fi   fi
216  }  }
217    
218  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
219  {  {
220   local i   local i
221    
# Line 268  dialog_setup_hdd_partitions_manuell() Line 248  dialog_setup_hdd_partitions_manuell()
248   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
249   then   then
250   dialog_setup_hdd_info   dialog_setup_hdd_info
251   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
252   fi   fi
253   fi   fi
254  }  }
# Line 602  EOF Line 544  EOF
544   fi   fi
545  }  }
546    
547  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
548  {  {
549   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
550    
551   ## hdds partitionieren manuell   ## hdds partitionieren manual
552   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
553  }  }
554    
555  setup_hdd_format()  setup_hdd_format()
556  {  {
  mkswap ${SWAPHDD} || dialog_die  
  mke2fs -j -q ${BOOTHDD} || dialog_die  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 setup_hdd_format_flash()  
 {  
557   mke2fs -j -q ${ROOTHDD} || dialog_die   mke2fs -j -q ${ROOTHDD} || dialog_die
558  }  }
559    
560  install_mount_rootfs()  install_mount_rootfs()
561  {  {
  swapon ${SWAPHDD} || dialog_die  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
562   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
563   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
564   cd ${INSTALLROOT} || dialog_die   cd ${INSTALLROOT} || dialog_die
# Line 863  install_system_settings() Line 779  install_system_settings()
779   # schreibe fstab   # schreibe fstab
780   if is_uuid_supported   if is_uuid_supported
781   then   then
  echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
782   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
783   else   else
  echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
784   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
785   fi   fi
786   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
# Line 891  install_system_settings() Line 805  install_system_settings()
805   fi   fi
806  }  }
807    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
 }  
   
808  install_umount_rootfs()  install_umount_rootfs()
809  {  {
810   cd /   cd /
811   umount ${INSTALLROOT}/boot || dialog_die   umount ${INSTALLROOT}/boot || dialog_die
812   umount ${INSTALLROOT} || dialog_die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLROOT} || dialog_die  
813  }  }
814    
815  install_do_reboot()  install_do_reboot()
# Line 931  run_install_normal() Line 825  run_install_normal()
825  {  {
826   dialog_hardware_detection   dialog_hardware_detection
827    
828   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
829   dialog_setup_hdd_format   dialog_setup_hdd_format
830   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
831   install_mount_rootfs   install_mount_rootfs
# Line 949  run_install_normal() Line 843  run_install_normal()
843   dialog_install_successful   dialog_install_successful
844  }  }
845    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
846  run_install_auto()  run_install_auto()
847  {  {
848   dialog_hardware_detection   dialog_hardware_detection
849    
850   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
851   dialog_setup_hdd_format   dialog_setup_hdd_format
852   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
853   install_mount_rootfs_flash   install_mount_rootfs
854   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
855    
856   dialog_install_settings   dialog_install_settings
857   sleep 1   sleep 1
858   install_system_settings_flash   install_system_settings
859   install_initrd_chroot   install_initrd_chroot
860    
861   dialog_install_bootsector   dialog_install_bootsector
862   install_bootsector_chroot   install_bootsector_chroot
863    
864   install_umount_rootfs_flash   install_umount_rootfs
865   dialog_install_successful   dialog_install_successful
866  }  }
867    
868    # set some proper traps
869    trap "trap_exit" SIGINT SIGQUIT
870    
871  dialog_main  dialog_main
872    
873  exit 0  exit 0

Legend:
Removed from v.2398  
changed lines
  Added in v.2415